"""
Find the n-th line of Pascal's triangle

Input Format
Integer number n.

Constraints
- 1 <= n <= 15

Output Format
Returns array with all integer numbers of n-th line of Pascal's triangle

Sample Input 0
1

Sample of Returned Value 0
[1]

Sample Input 1
7

Sample of Returned Value 1
[1, 6, 15, 20, 15, 6, 1]

"""
from math import factorial as fact

def pascal_triangle_line(n):
    list = []
    for i in range(n):
        list.append(int(fact(n-1)/(fact(i)*fact(n-1-i))))
    return list


########################################################################
#               Tests                                                  #
########################################################################

ib113_inputs = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15]
ib113_outputs = [[1],
                 [1, 1],
                 [1, 2, 1],
                 [1, 3, 3, 1],
                 [1, 4, 6, 4, 1],
                 [1, 5, 10, 10, 5, 1],
                 [1, 6, 15, 20, 15, 6, 1],
                 [1, 7, 21, 35, 35, 21, 7, 1],
                 [1, 8, 28, 56, 70, 56, 28, 8, 1],
                 [1, 9, 36, 84, 126, 126, 84, 36, 9, 1],
                 [1, 10, 45, 120, 210, 252, 210, 120, 45, 10, 1],
                 [1, 11, 55, 165, 330, 462, 462, 330, 165, 55, 11, 1],
                 [1, 12, 66, 220, 495, 792, 924, 792, 495, 220, 66, 12, 1],
                 [1, 13, 78, 286, 715, 1287, 1716, 1716, 1287, 715, 286, 78,
                  13, 1],
                 [1, 14, 91, 364, 1001, 2002, 3003, 3432, 3003, 2002, 1001,
                  364, 91, 14, 1]]


def ib113_test_pascal_triangle_line():
    count = 0
    length = len(ib113_inputs)

    for i in range(length):
        res = pascal_triangle_line(ib113_inputs[i])

        if not isinstance(res, list) or res != ib113_outputs[i]:
            count += 1

    if count == 0:
        print("OK. All tests passed.")
    else:
        print("Wrong answer. Only %d / %d of tests passed." %
              (length - count, length))


if __name__ == '__main__':
    ib113_test_pascal_triangle_line()
