"""
Given a quadratic equation in the form ax2 + bx + c, find floor of roots of it.
Floor of 5.6 is 5, floor of -1.4 is -2 (you can use math.floor(x) and
math.sqrt(x) functions).

Input Format
Three numbers a, b and c separated by space

Constraints
1 <= a <= 10
1 <= b <= 10
-10 <= c <= 10
D is determinant of quadratic equation
D >= 0

Output Format
Returns sorted list that contains one or two values that represents root(s) of
quadratic equation. Sorted means that the lowest value is the first in the
list.

Sample Input 0
1 4 -3

Sample Output 0
[-4, 0]

Explanation 0
Determinant SQRT(B**2 - 4*a*c) is equal to SQRT(28) which is approximately
5,2915. First root is equal to ((-4 - 5,2915) / 2) = -4,64575 and floor from
this number is equal to 5. Second root is equal to ((-4 + 5,2915) / 2) =
0,64575 and floor from this number is equal to 0.

Sample Input 0
1 4 -3

Sample Output 0
[-4, 0]
"""

from math import sqrt, floor


def quadratic_equation(a, b, c):
    D = b ** 2 - 4 * a * c
    x1 = (-b - sqrt(D)) / (2 * a)
    x2 = (-b + sqrt(D)) / (2 * a)
    if x1 == x2:
        return [floor(x1)]
    return [floor(x1), floor(x2)]


########################################################################
#               Tests                                                  #
########################################################################

ib113_inputs = [[1, 1, -1], [1, 4, -3], [1, 1, -10], [1, 3, -4], [1, 2, 1]]
ib113_outputs = [[-2, 0], [-5, 0], [-4, 2], [-4, 1], [-1]]


def ib113_test_quadratic_equation():
    count = 0
    length = len(ib113_inputs)

    for i in range(length):
        res = quadratic_equation(ib113_inputs[i][0], ib113_inputs[i][1],
                                 ib113_inputs[i][2])

        if not isinstance(res, list) or res != ib113_outputs[i]:
            count += 1

    if count == 0:
        print("OK. All tests passed.")
    else:
        print("Wrong answer. Only %d / %d of tests passed." %
              (length - count, length))


if __name__ == '__main__':
    ib113_test_quadratic_equation()
