# ################################## HW5 ################################## #
"""
Pokyny:
- Deadline odevzdani: 7. 12. 23:59
- Odevzdejte jediny soubor
    - Student - IB113 - Odevzdavarny - Skupina 01 (pripadne 02) - DU 5
- Muzete si vytvaret pomocne funkce, pokud chcete.
- V pripade, ze chcete vytvaret vlastni testy, vkladete je na prislusne misto
    na konci souboru.
    - Pred odevzdanim vlastni modifikace smazte.
- Piste srozumitelny kod, pouzivejte vhodne nazvy promennych a funkci.
- Dodrzujte standard pep8.
    - Budu kontrolovat a strhavat body za jeho nedodrzeni.
- Nemente hlavicky pripravenych funkci.
- Pripadne nejasnosti muzete resit v diskuznim foru. Pokud by ale mela otazka
    obsahovat kusy kodu, nebo neco, co by mohli ostatni studenti opsat, tak
    napiste radeji email.
- Pokud nevite, jak nejaky priklad vyresit kompletne, napiste do komentare,
    co vasemu reseni chybi.
- Neopisujte. Nestoji to za to. Dostanete zaporne body a budete muset ulohu
    stejne vypracovat sami.

Zadani:
Dostupné na adrese: http://www.fi.muni.cz/~xplhak/IB111/05-objekty.html
"""

from random import randint


class Attack(object):

    def __init__(self, name, power, accuracy, stamina):
        self.name = name
        self.power = power
        self.accuracy = accuracy
        self.stamina = stamina

    def get_name(self):
        return self.name

    def get_power(self):
        return self.power

    def get_stamina(self):
        return self.stamina

    def is_hit(self):
        if randint(1, 100) > self.accuracy:
            return False
        else:
            return True

    def count_hit(self):
        return round(randint(80, 120) / 100 * self.power)

    def __str__(self):
        return str(self.name) + ': Power = ' + str(self.power) + \
               ', Accuracy = ' + str(self.accuracy) + ', Stamina = ' + \
               str(self.stamina)

    # --------------------------------------------------------


#   Prisera
# --------------------------------------------------------
class Creature(object):

    def __init__(self, name, full_health, full_energy, speed, attacks):
        self.name = name
        self.fullh = full_health
        self.fulle = full_energy
        self.speed = speed
        self.attacks = attacks
        self.health = full_health
        self.energy = full_energy

    def get_name(self):
        return self.name

    def get_health(self):
        return self.health

    def get_energy(self):
        return self.energy

    def get_speed(self):
        return self.speed

    def get_attack(self, option):
        if option > len(self.attacks):
            return None
        else:
            return self.attacks[option]

    def get_random_attack(self):
        return self.attacks[randint(1, len(self.attacks)) - 1]

    def decrease_health(self, wounds):
        if self.health - wounds < 0:
            self.health = 0
            return wounds
        else:
            self.health -= wounds
            return wounds

    def decrease_energy(self, effort):
        if self.energy - effort < 0:
            self.energy = 0
        else:
            self.energy -= effort

    def rest(self):
        if self.energy + int(self.fulle * 0.1) > self.fulle:
            self.energy = self.fulle
        else:
            self.energy += int(self.fulle * 0.1)

    def is_attack_makeable(self, attack):
        if self.energy >= attack.get_stamina():
            return True
        else:
            return False

    def is_dead(self):
        if self.health <= 0:
            return True
        else:
            return False

    def get_lowest_attack_energy(self):
        minimal_energy = self.fulle
        for i in self.attacks:
            if i.get_stamina() < minimal_energy:
                minimal_energy = i.get_stamina()
        return minimal_energy

    def resolve_hit(self, attack, defender):
        self.decrease_energy(attack.get_stamina())
        if attack.is_hit():
            return defender.decrease_health(attack.count_hit())
        else:
            return 0

    def print_attacks(self):
        x = 1
        for i in self.attacks:
            print(str(x) + '. ' + i.__str__())
            x += 1
        print(str(x) + '. Rest\n')

    def __str__(self):
        return str(self.name) + ': Health = ' + str(self.health) + '/' + \
               str(self.fullh) + ', Stamina = ' + str(self.energy) + '/' + \
               str(self.fulle)


# --------------------------------------------------------
#  Zapas
# --------------------------------------------------------\
class Match(object):

    def __init__(self, creatures, mode, players_creature):
        self.creatures = creatures
        self.mode = mode
        self.player = self.creatures[players_creature]
        if players_creature == 1:
            self.enemy = self.creatures[0]
        else:
            self.enemy = self.creatures[1]
        self.my_turn = True

    def run(self):
        if self.mode == 1:
            self.header_singl()
            self.attacks_first()
            while True:
                self.one_round_singl()
                self.state_singl()
                if self.player.is_dead():
                    print("You died.")
                    break
                elif self.enemy.is_dead():
                    print("You killed %s." % self.enemy.get_name())
                    break
        elif self.mode == 2:
            self.header_multi()
            self.attacks_first()
            while True:
                self.one_round_multi()
                self.state_multi()
                if self.player.is_dead():
                    print("Player 1 died.")
                    break
                elif self.enemy.is_dead():
                    print("Player 2 died.")
                    break

    def one_round_singl(self):
        if self.my_turn:
            print("Your turn.\n")
            self.player.print_attacks()
            choice = int(input("What attack do you want to use: ")) - 1
            if choice == len(self.player.attacks):
                self.player.rest()
                print("You feel rest.\n")
                self.my_turn = False
            elif choice < len(self.player.attacks):
                self.player_attacks(self.player.get_attack(choice))
        elif not self.my_turn:
            print("Enemy's turn.\n")
            if self.enemy.get_energy() < self.enemy.get_lowest_attack_energy():
                self.enemy.rest()
                print("Enemy rests.\n")
                self.my_turn = True
            else:
                self.enemy_attacks()

    def one_round_multi(self):
        if self.my_turn:
            print("Player 1's turn.\n")
            self.player.print_attacks()
            choice = int(input("What attack do you want to use: ")) - 1
            if choice == len(self.player.attacks):
                self.player.rest()
                print("Player 1 rests.\n")
                self.my_turn = False
            elif choice < len(self.player.attacks):
                self.player1_attacks(self.player.get_attack(choice))
        elif not self.my_turn:
            print("Player 2's turn.\n")
            self.enemy.print_attacks()
            choice = int(input("What attack do you want to use: ")) - 1
            if choice == len(self.enemy.attacks):
                self.enemy.rest()
                print("Player 2 rests.\n")
                self.my_turn = True
            elif choice < len(self.enemy.attacks):
                self.player2_attacks(self.enemy.get_attack(choice))

    def player_attacks(self, attack):
        if self.player.is_attack_makeable(attack):
            dmg = self.player.resolve_hit(attack, self.enemy)
            if dmg > 0:
                print("\nYou casted %s.\n" % attack.get_name())
                print("You decreased health of your enemy by %d pts.\n" % dmg)
            elif dmg == 0:
                print("\nYour attack was not successfull.\n")
            self.my_turn = False
        else:
            print("\nYou don't have enough energy to do this attack.\n")
            print("Choose another attack.\n")
            self.my_turn = True

    def enemy_attacks(self):
        attack = self.enemy.get_random_attack()
        if self.enemy.is_attack_makeable(attack):
            dmg = self.enemy.resolve_hit(attack, self.player)
            if dmg > 0:
                print("Enemy casts %s on you.\n" % attack.name)
                print("Your health has been decreased by %d pts.\n" % dmg)
            elif dmg == 0:
                print("Enemy's attack was not successfull.\n")
            self.my_turn = True
        else:
            self.my_turn = False

    def player1_attacks(self, attack):
        if self.player.is_attack_makeable(attack):
            dmg = self.player.resolve_hit(attack, self.enemy)
            if dmg > 0:
                print("\nPlayer 1 casted %s.\n" % attack.get_name())
                print("Player 1 decreased health of Player 2 by %d pts.\n" % dmg)
            elif dmg == 0:
                print("\nPlayer 1's attack was not successfull.\n")
            self.my_turn = False
        else:
            print("\nPlayer 1 does not have enough energy to do this attack.\n")
            print("Choose another attack.\n")
            self.my_turn = True

    def player2_attacks(self, attack):
        if self.enemy.is_attack_makeable(attack):
            dmg = self.enemy.resolve_hit(attack, self.player)
            if dmg > 0:
                print("\nPlayer 2 casted %s.\n" % attack.get_name())
                print("Player 2 decreased health of Player 1 by %d pts.\n" % dmg)
            elif dmg == 0:
                print("\nPlayer 2's attack was not successfull.\n")
            self.my_turn = True
        else:
            print("\nPlayer 2 does not have enough energy to do this attack.\n")
            print("Choose another attack.\n")
            self.my_turn = False

    def attacks_first(self):
        if self.player.get_speed() > self.enemy.get_speed():
            self.my_turn = True
        else:
            self.my_turn = False

    def header_singl(self):
        print("\nYou have chosen %s as your creature.\n" % self.player)
        print("Your enemy is %s.\n" % self.enemy)

    def header_multi(self):
        print("\nPlayer 1 have chosen %s as his creature.\n" % self.player)
        print("Player 2 has been assigned %s as his creature.\n" % self.enemy)

    def state_singl(self):
        print("Your state:")
        print(self.player.__str__() + '\n')
        print("Enemy's state:")
        print(self.enemy.__str__() + '\n')

    def state_multi(self):
        print("Player 1's state:")
        print(self.player.__str__() + '\n')
        print("Player 2's state:")
        print(self.enemy.__str__() + '\n')


########################################################################
#               Nasleduje kod testu,                                   #
########################################################################

def test_is_hit():
    print("************* TEST IS_HIT *************")

    attack = Attack('Fire breath', 100, 50, 25)
    counter = 0

    for i in range(10000):
        if attack.is_hit():
            counter += 1

    if counter > 8000 or counter < 2000:
        print("NOK: Funkce vracila %d uspechu z 10000 ale melo by byt vraceno"
              " cca 5000 uspechu." % counter)
        return False

    print("OK")
    return True


def test_count_hit():
    print("************* TEST COUNT_HIT *************")

    attack = Attack('Fire breath', 100, 50, 25)
    if attack.get_power() <= 0:
        print("NOK: Test nelze spustit, jelikoz nefunguje funkce get_power.")
        return False

    for i in range(10000):
        actual_power = attack.count_hit()
        if actual_power < (0.8 * attack.get_power()) or actual_power > \
                (1.2 * attack.get_power()):
            print("NOK: Byla vracena hodnota utoku %d, ktera je mimo povolene "
                  "rozmezi %d-%d." % (actual_power,
                                      int(0.8 * attack.get_power()),
                                      int(1.2 * attack.get_power())))
            return False

    print("OK")
    return True


def test_get_attack():
    print("************* TEST GET_ATTACK *************")

    attacks = [Attack('Fire breath', 100, 50, 25),
               Attack('Ice breath', 100, 50, 25),
               Attack('Whirlwind', 100, 50, 25)]
    monster = Creature('Drogon', 200, 100, 9, attacks)

    if monster.get_attack(0) is None:
        print("NOK: Chyba pri vraceni utoku. Test nelze spustit, jelikoz"
              "get_attack vraci None.")
        return False

    for i in range(3):
        attack = monster.get_attack(i)
        if attack != attacks[i]:
            print("NOK: Chyba pri vraceni utoku. Byl ocekavan utok:\n"
                  "%s\n ale byl vracen utok:\n%s" % (attacks[i], attack))
            return False

    if monster.get_attack(4) is not None:
        print("NOK: Chyba pri vraceni utoku. Utok na indexu 4 neexistuje a"
              "mela byt vracena hodnota None")
        return False

    print("OK")
    return True


def test_get_random_attack():
    print("************* TEST GET_RANDOM_ATTACK *************")

    attacks = [Attack('Fire breath', 100, 50, 25),
               Attack('Ice breath', 100, 50, 25),
               Attack('Whirlwind', 100, 50, 25)]
    monster = Creature('Drogon', 200, 100, 9, attacks)

    attack = monster.get_random_attack()
    for i in range(1000):
        if attack is None:
            print("NOK: Pri volbe nahodneho utoku byla vracena hodnota None.")
            return False
        attack = monster.get_random_attack()

    counter = 0
    for i in range(1000):
        if monster.get_random_attack() == attack:
            counter += 1

    if counter > 990:
        print("NOK: Chyba pri vraceni nahodneho utoku. Byl ocekavan stale"
              "vracen stejny utok: %s" % (attacks[i], attack))
        return False

    print("OK")
    return True


def test_decrease_health():
    print("************* TEST DECREASE_HEALTH *************")

    monster = Creature('Drogon', 200, 100, 9,
                       [Attack('Fire breath', 100, 50, 25)])

    monster.decrease_health(50)
    if monster.get_health() != 150:
        print("NOK: Po snizeni o 50 zivotu nebyla vracena spravna hodnota "
              "aktualnich zivotu prisery. Byla ocekavana hodnota 150, ale "
              "byla vracena hodnota %d." % monster.get_health())
        return False

    monster.decrease_health(175)
    if monster.get_health() < 0:
        print("NOK: Po snizeni o 175 zivotu nebyla vracena spravna hodnota "
              "aktualnich zivotu prisery. Byla ocekavana hodnota 0, ale "
              "byla vracena hodnota %d." % monster.get_health())
        return False

    print("OK")
    return True


def test_decrease_energy():
    print("************* TEST DECREASE_ENERGY *************")

    monster = Creature('Drogon', 200, 100, 9,
                       [Attack('Fire breath', 100, 50, 25)])

    monster.decrease_energy(25)
    if monster.get_energy() != 75:
        print("NOK: Po snizeni o 25 energie nebyla vracena spravna hodnota "
              "aktualni energie prisery. Byla ocekavana hodnota 75, ale "
              "byla vracena hodnota %d." % monster.get_energy())
        return False

    monster.decrease_energy(175)
    if monster.get_energy() < 0:
        print("NOK: Po snizeni o 175 energie nebyla vracena spravna hodnota "
              "aktualni energie prisery. Byla ocekavana hodnota 0, ale "
              "byla vracena hodnota %d." % monster.get_energy())
        return False

    print("OK")
    return True


def test_rest():
    print("************* TEST REST *************")

    monster = Creature('Drogon', 200, 99, 9,
                       [Attack('Fire breath', 100, 50, 25)])

    monster.decrease_energy(11)
    monster.rest()
    if monster.get_energy() != 97:
        print("NOK: Problem ve funkci rest. Prisera se max_health rovno 99 a "
              "aktualni energii 88 by mela po odpocinku mit 97 energie. Ale "
              "byla vracena hodnota %d." % monster.get_energy())
        return False

    monster.rest()
    monster.rest()
    if monster.get_energy() > 99:
        print("NOK: Problem ve funkci rest. Prisera se max_health rovno 99 "
              "nemuze po odpocinku ziskat vice energie, nez je jeji maximul. "
              "Ale presto byla vracena hodnota %d." % monster.get_energy())
        return False

    print("OK")
    return True


def test_is_attack_makeable():
    print("************* TEST IS_ATTACK_MAKEABLE *************")

    attack = Attack('Fire breath', 100, 50, 40)
    monster = Creature('Drogon', 200, 100, 9, [attack])

    if monster.is_attack_makeable(attack) is not True:
        print("NOK: Neni mozne provest utok o energeticke narocnosti 40, "
              "presto, ze nestvura ma dostatek energie (100).")
        return False

    monster.decrease_energy(75)
    if monster.is_attack_makeable(attack) is True:
        print("NOK: Je mozne provest utok o energeticke narocnosti 40, "
              "presto, ze nestvura nema dostatek energie (25).")
        return False

    print("OK")
    return True


def test_is_dead():
    print("************* TEST IS_DEAD *************")

    attack = Attack('Fire breath', 100, 50, 40)
    monster = Creature('Drogon', 200, 100, 9, [attack])

    if monster.is_dead() is True:
        print("NOK: Prisera byla oznacena za mrtvou, prestoze ma %d zivotu."
              % monster.get_health())
        return False

    monster.decrease_health(199)
    if monster.is_dead() is True:
        print("NOK: Prisera byla oznacena za mrtvou, prestoze ma %d zivotu."
              % monster.get_health())
        return False

    monster.decrease_health(199)
    if monster.is_dead() is not True:
        print("NOK: Prisera nebyla oznacena za mrtvou, prestoze ma %d zivotu."
              % monster.get_health())
        return False

    print("OK")
    return True


def test_get_lowest_attack_energy():
    print("************* TEST GET_LOWEST_ATTACK_ENERGY *************")

    monster = Creature('Drogon', 200, 99, 9,
                       [Attack('Fire breath', 100, 50, 25)])
    if monster.get_lowest_attack_energy() != 25:
        print("NOK: Nebyl korektne vracen nejsnadnejsi utok - vracena byla"
              "hodnota %d, ale ocekavana byla hodnota 25."
              % monster.get_lowest_attack_energy())
        return False

    dragon_attacks = [
        Attack('Fire breath', 50, 40, 25),
        Attack('Kick', 10, 20, 10),
        Attack('Tail slash', 35, 80, 15),
        Attack('Tail twist', 50, 50, 20)
    ]
    monster = Creature('Drogon', 200, 100, 9, dragon_attacks)

    if monster.get_lowest_attack_energy() != 10:
        print("NOK: Nebyl korektne vracen nejsnadnejsi utok - vracena byla"
              "hodnota %d, ale ocekavana byla hodnota 10.")
        return False

    print("OK")
    return True


def test_resolve_hit():
    print("************* TEST RESOLVE_HIT *************")
    attacker = Creature('Drogon', 200, 100, 9,
                        [Attack('Fire breath', 100, 50, 25)])
    defender = Creature('Viserion', 150, 80, 9,
                        [Attack('Fire breath', 100, 50, 25)])

    old_health = defender.get_health()
    old_energy = attacker.get_energy()
    attack = attacker.get_random_attack()
    hit = attacker.resolve_hit(attack, defender)

    if defender.get_health() != old_health - hit:
        print("NOK: Nebyl korektne vracen vyresen utok - branici prisera"
              "mela byt poskozena o %d a mit tedy %d zivotu, ale ma jich %d."
              % (hit, old_health - hit, defender.get_health()))
        return False

    if attacker.get_energy() != old_energy - 25:
        print("NOK: Nebyl korektne vracen vyresen utok - utocici prisera"
              "mela mit energii snizenu o 25 a mit tedy %d energie, ale ma "
              "ji %d." % (old_energy - 25, defender.get_energy()))
        return False

    print("OK")
    return True


def test_choose_creature(creature_a, creature_b):
    print("1. " + str(creature_a))
    print("2. " + str(creature_b))
    return int(input("What creature should be yours?: "))


def test_main():
    dragon_attacks = [
        Attack('Fire breath', 50, 40, 25),
        Attack('Kick', 10, 20, 10),
        Attack('Tail slash', 35, 80, 15),
        Attack('Tail twist', 50, 50, 20)
    ]
    spider_attacks = [
        Attack('Web', 25, 90, 15),
        Attack('Bite', 10, 50, 10),
        Attack('Acid splash', 40, 60, 20),
    ]
    dragon = Creature("Dragon", 150, 50, 10, dragon_attacks)
    green_dragon = Creature("Viserion", 100, 40, 3, spider_attacks)

    mode = int(input("Zadejte mod hry - (1) Single player (2) Multiplayer: "))
    player = test_choose_creature(dragon, green_dragon)

    match = Match([dragon, green_dragon], mode, player - 1)
    match.run()


# Hlavni funkce volana automaticky po spusteni programu.
if __name__ == '__main__':
    initial_tests_correct = True
#    initial_tests_correct = test_is_hit()
#    initial_tests_correct = test_count_hit()
#    initial_tests_correct = test_get_attack()
#    initial_tests_correct = test_get_random_attack()
#    initial_tests_correct = test_decrease_health()
#    initial_tests_correct = test_decrease_energy()
#    initial_tests_correct = test_rest()
#    initial_tests_correct = test_is_attack_makeable()
#    initial_tests_correct = test_is_dead()
#    initial_tests_correct = test_get_lowest_attack_energy()
#    initial_tests_correct = test_resolve_hit()

    if initial_tests_correct:
        print("***** Spoustim zkusebni hru *****")
        test_main()
